$(document.body).ready(function() {
    var isRepeat = false,
        score = 5,
        tag = "",
        solved = 1,
        remar = "";
    var param = {};
    var humanSetInnerStepOneHtml = function() {
        $aLi = $("#star li");
        $(".js-solved").addClass("solveActive");
        fnPoint(score);
        $(".js-evaluateTip").html(config[score - 1].scoreExplain);
        var iStar = 0;
        for (i = 1; i <= $aLi.length; i++) {
            $aLi[i - 1].index = i;
            //鼠标移过显示分数
            $aLi[i - 1].onmouseover = function() {
                fnPoint(this.index);
            };
            //鼠标离开后恢复上次评分
            $aLi[i - 1].onmouseout = function() {
                fnPoint(this.index);
            };
            //点击后进行评分处理
            $($aLi[i - 1]).bind("click", function() {
                iStar = this.index;
                switch (iStar) {
                    case 1: //一星
                    case 2: //二星
                    case 3: //三星
                    case 4: //四星
                        score = iStar;
                        humanSetInnerStepTwoHtml(iStar);
                        $(".js-evaluateDetail").css("display", "block");
                        break;
                    case 5: //五星
                        score = 5;
                        $(".js-evaluateDetail").css("display", "none");
                        break;
                };
                $(".js-evaluateTip").html(config[score - 1].scoreExplain);

            });
        };
        if (config[0].isQuestionFlag) {
            $(".js-operateType").html('<p class="operateTypeTitle">请问客服是否解决了您的问题？</p>' +
                '<div class="operateTypeBtn">' +
                '<p class="solve solved js-solved solveActive"><span></span>已解决</p>' +
                '<p class="solve unSolved js-unSolved" style="margin-left:25px;"><span></span>未解决</p>' +
                '</div>');
        }


    };
    var humanSetInnerStepTwoHtml = function() {
        var list = [];

        if (config[score - 1].labelName) {
            list = config[score - 1].labelName.split(",");

        }
        //去掉空标签
        for (var i = 0; i < list.length; i++) {
            if (list[i] == "") {
                list.splice(i, 1);
            }
        };
        var $li = "";
        for (var i = 0; i < list.length; i++) {
            if (i % 2 == 0) {
                $li += '<span class="tag js-situationSpan" style="float:left;">' + list[i] + '</span>';
            } else {
                $li += '<span class="tag js-situationSpan" style="float:right;">' + list[i] + '</span>';
            }
        };
        if (list.length > 0) {
            $(".js-h2").css('display',"block");
        } else {
            $(".js-h2").css('display',"none");
        }
        $(".js-situation").html($li);
        $(".js-situationSpan").click(function() {
            if ($(this).hasClass("active")) {
                $(this).css({ "background": "#fff", "border": "1px solid #c4cdcc", "color": "#686d70" });
                $(this).removeClass("active")
            } else {
                $(this).css({ "background": "#0daeaf", "border": "1px solid #0daeaf", "color": "#fff" });
                $(this).addClass("active")
            }
        });
        //alert(!!config[score - 1].inputLanguage);
        if (!!config[score - 1].inputLanguage) {
            $(".js-evaluateInner").attr("placeholder", config[score - 1].isInputMust ? config[score - 1].inputLanguage + '（必填）' : config[score - 1].inputLanguage + '（选填）');
        } else {
            $(".js-evaluateInner").attr("placeholder", config[score - 1].isInputMust ? '欢迎给我们服务提建议～（必填）' : '欢迎给我们服务提建议～（选填）');

        }
    };
    var EvaluateAjaxHandler = function() {
        if (isRepeat == false) {
            isRepeat = true;
            var tagArr = [],
                tagNum = $(".js-situationSpan").length;
            $(".js-situationSpan").each(function() {
                var _val = $(this).html();
                if ($(this).hasClass("active")) {
                    tagArr.push(_val)
                }
            });
            if (tagArr.length == 0 && config[score - 1].isTagMust && score != 5 && tagNum > 0) {
                alert('请选择评价标签');
                setTimeout(function() {
                    isRepeat = false;
                }, 3000);
                return;
            };
            tag = tagArr.join(",");
            //评价详情是否为必选
            remark = $(".js-evaluateInner").val() || '';
            if (remark == "" && config[score - 1].isInputMust && score != 5) {
                alert('请填写评价详情');
                setTimeout(function() {
                    isRepeat = false;
                }, 3000)
                return;
            }
            if (config[0].isQuestionFlag == 1) {
                if ($(".js-solved").hasClass("solveActive")) {
                    solved = 1;
                } else {
                    solved = 0;
                }
            }else{
                    solved = -1;

            };
            $.ajax({
                type: "post",
                url: "/chat/user/comment.action",
                dataType: "json",
                data: {
                    cid: param["cid"],
                    visitorId: param["uid"],
                    score: score,
                    tag: tag,
                    solved: solved,
                    remark: remark,
                    type: 1,
                    //0,邀请评价，1为主动评价
                    commentType: param["commentType"]
                },
                success: function(req) {
                    if (req.status === 1) {
                        //window.open('./evaSuccess.html');
                        window.location.href = './evaSuccess.html';
                    } else {
                        alert("提交失败");
                    }
                },
                //请检查网络链接
                error: function() {
                    alert("提交失败,请检查网络链接");
                }
            });
            setTimeout(function() {
                isRepeat = false;
            }, 3000)
        }
    };
    var fnPoint = function(iArg) { //alert(iArg);
        //分数赋值
        for (var i = 0; i < $aLi.length; i++) {
            $aLi[i].className = i < iArg ? "on" : "";
        }
    };
    var getQueryParam = function(href) {
        href = href || document.location.href;
        var queryString = href.substring(href.lastIndexOf("?") + 1);
        if (queryString.lastIndexOf("#") >= 0) {
            queryString = queryString.substring(0, queryString.lastIndexOf("#"));
        };
        var list = queryString.split("&");
        for (var i = 0; i < list.length; i++) {
            var item = list[i];
            try {
                var key = item.substring(0, item.indexOf("="));
                var value = item.substring(item.indexOf("=") + 1);
                if (key.length == 0) {
                    continue;
                }

                if (/^-?(\d+)(\.\d+)?$/.test(value)) {
                    if (("" + value).length > 10) {
                        param[key] = "" + value;
                    } else {
                        param[key] = Number(value);
                    }
                } else if (value === 'true') {
                    param[key] = true;
                } else if (value === 'false') {
                    param[key] = false;
                } else {
                    param[key] = decodeUrl(value);
                }
            } catch (e) {
                continue;
            }
        }
        return param;
    };
    var decodeUrl = function(str) {
        if (typeof str === 'string') {
            return decodeURIComponent(str);
        } else {
            return undefined;
        }

    };
    var commitBefore = function() {
        $.ajax({
            type: "post",
            url: "/chat/user/isComment.action",
            dataType: "json",
            data: {
                cid: param["cid"],
                uid: param["uid"],
                type: 1
            },
            success: function(req) {
                var isEvaluated = req.isComment;
                //alert(isEvaluated);
                //1表示评论过
                if (isEvaluated == 1) {
                    alert("您已评价，不能重复提交");
                } else if (isEvaluated == 0) { //0表示说过话没有评论过
                    EvaluateAjaxHandler();
                } else { //-1表示用户没有说过话
                    alert("评价页面过期失效啦，欢迎下次及时进行评价哦~~");
                    //微信无此种情况
                }
            }
        })
    };
    var bindListener = function() {
        $(".js-submit").on("click", commitBefore);
        $(document.body).delegate(".js-solved", "click", function() {
            if (!$(this).hasClass("solveActive")) {
                $(this).addClass("solveActive");
                $(".js-unSolved").removeClass("unsolveActive");
            }
        });
        $(document.body).delegate(".js-unSolved", "click", function() {
            if (!$(this).hasClass("unsolveActive")) {
                $(this).addClass("unsolveActive");
                $(".js-solved").removeClass("solveActive");
            }
        });

        $(window).scroll(function() {
            $(".js-submit").css("bottom", 0)
        })
    };
    var parseDOM = function() {
        $body = $(document.body);
    };
    var initFunction = function() {
        parseDOM();
        humanSetInnerStepOneHtml();
        bindListener();
    };
    var initConfig = function() {
        $.ajax({
            type: "get",
            url: "/chat/user/satisfactionMessage.action",
            dataType: "json",
            data: {
                uid: param["uid"]
            },
            success: function(req) {
                if (req.status === 1) {
                    config = req.data;
                    initFunction();
                    $('.evabody').css("background", "none");
                    $('.js-evamode').css("display", "block");
                    $('.js-submit').css("display", "block");
                }
            },
            //请检查网络链接
            error: function() {
                //showTip.show('请检查网络链接');
            }
        });
    };
    var init = function() {
        getQueryParam();
        // console.log(param["cid"]);
        if (isRepeat == false) {
            isRepeat = true;
            $.ajax({
                type: "post",
                url: "/chat/user/isComment.action",
                dataType: "json",
                data: {
                    cid: param["cid"],
                    uid: param["uid"],
                    type: 1
                },
                success: function(req) {
                    var isEvaluated = req.isComment;
                    //console.log(req.isComment);
                    //alert(isEvaluated);
                    //1表示评论过
                    if (isEvaluated == 1) {
                        window.location.href = './evaSuccess.html';
                    } else if (isEvaluated == 0) { //0表示说过话没有评论过

                        initConfig();
                    } else { //-1表示用户没有说过话
                    alert("评价页面过期失效啦，欢迎下次及时进行评价哦~~");
                        
                        //微信无此种情况
                    }
                }
            });
            //防止快速点击
            setTimeout(function() {
                isRepeat = false;
            }, 1000)
        }
    };
    init();
})